//--------------------------------------------
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "mated.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(ID_MENU1_BOX, OnMenu1Box)
	ON_UPDATE_COMMAND_UI(ID_MENU1_BOX, OnUpdateMenu1Box)
	ON_COMMAND(ID_MENU1_FLAT, OnMenu1Flat)
	ON_UPDATE_COMMAND_UI(ID_MENU1_FLAT, OnUpdateMenu1Flat)
	ON_COMMAND(ID_MENU1_SMOOTH, OnMenu1Smooth)
	ON_UPDATE_COMMAND_UI(ID_MENU1_SMOOTH, OnUpdateMenu1Smooth)
	ON_COMMAND(ID_MENU1_SPHERE, OnMenu1Sphere)
	ON_UPDATE_COMMAND_UI(ID_MENU1_SPHERE, OnUpdateMenu1Sphere)
	ON_COMMAND(ID_MENU1_SURF, OnMenu1Surf)
	ON_UPDATE_COMMAND_UI(ID_MENU1_SURF, OnUpdateMenu1Surf)
	ON_COMMAND(ID_MENU1_B_BLACK, OnMenu1BBlack)
	ON_COMMAND(ID_MENU1_B_GRAY, OnMenu1BGray)
	ON_COMMAND(ID_MENU1_B_WHITE, OnMenu1BWhite)
	ON_UPDATE_COMMAND_UI(ID_MENU1_B_BLACK, OnUpdateMenu1BBlack)
	ON_UPDATE_COMMAND_UI(ID_MENU1_B_GRAY, OnUpdateMenu1BGray)
	ON_UPDATE_COMMAND_UI(ID_MENU1_B_WHITE, OnUpdateMenu1BWhite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*
static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};
*/

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_figtype=0;
	m_smooth=TRUE;
	m_bcolor=1;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    // a resonable size, could do more on this topic
	// ini-file etc
	cs.cy = 520; 
    cs.cx = 680; 
	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	
	pPopupMenu->EnableMenuItem(ID_MENU1_SMOOTH,MF_BYCOMMAND|MF_ENABLED);
	pPopupMenu->EnableMenuItem(ID_MENU1_FLAT,MF_BYCOMMAND|MF_ENABLED);
	
	pPopupMenu->EnableMenuItem(ID_MENU1_SPHERE,MF_BYCOMMAND|MF_ENABLED);
	pPopupMenu->EnableMenuItem(ID_MENU1_BOX,MF_BYCOMMAND|MF_ENABLED);
	pPopupMenu->EnableMenuItem(ID_MENU1_SURF,MF_BYCOMMAND|MF_ENABLED);

	pPopupMenu->EnableMenuItem(ID_MENU1_B_BLACK,MF_BYCOMMAND|MF_ENABLED);
	pPopupMenu->EnableMenuItem(ID_MENU1_B_GRAY,MF_BYCOMMAND|MF_ENABLED);
	pPopupMenu->EnableMenuItem(ID_MENU1_B_WHITE,MF_BYCOMMAND|MF_ENABLED);
	
}


/////////  figtype  //////////////

void CMainFrame::OnMenu1Sphere() 
{
	if(m_figtype!=0)
	{	m_figtype=0;RedrawWindow();}
}

void CMainFrame::OnMenu1Box() 
{
	if(m_figtype!=1)
	{	m_figtype=1;RedrawWindow();	}
}
void CMainFrame::OnMenu1Surf() 
{
	if(m_figtype!=2)
	{	m_figtype=2;RedrawWindow();	}
}

void CMainFrame::OnUpdateMenu1Sphere(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck(m_figtype==0); }
void CMainFrame::OnUpdateMenu1Box(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck(m_figtype==1); }

void CMainFrame::OnUpdateMenu1Surf(CCmdUI* pCmdUI) 
{	pCmdUI->SetCheck(m_figtype==2); }

///// shading ///////////


void CMainFrame::OnMenu1Flat() 
{
	if(m_smooth){m_smooth=FALSE;RedrawWindow();	}
}
void CMainFrame::OnMenu1Smooth() 
{
	if(!m_smooth){m_smooth=TRUE;RedrawWindow();	}
}


void CMainFrame::OnUpdateMenu1Flat(CCmdUI* pCmdUI) 
{pCmdUI->SetCheck(!m_smooth);}


void CMainFrame::OnUpdateMenu1Smooth(CCmdUI* pCmdUI) 
{pCmdUI->SetCheck(m_smooth);}

///////  background /////////////

void CMainFrame::OnMenu1BBlack() 
{
	if(m_bcolor!=0){m_bcolor=0;RedrawWindow();}
}

void CMainFrame::OnMenu1BGray() 
{
	if(m_bcolor!=1){m_bcolor=1;RedrawWindow();}
}

void CMainFrame::OnMenu1BWhite() 
{
	if(m_bcolor!=2){m_bcolor=2;RedrawWindow();}
}

void CMainFrame::OnUpdateMenu1BBlack(CCmdUI* pCmdUI) 
{pCmdUI->SetCheck(m_bcolor==0);}

void CMainFrame::OnUpdateMenu1BGray(CCmdUI* pCmdUI) 
{pCmdUI->SetCheck(m_bcolor==1);}

void CMainFrame::OnUpdateMenu1BWhite(CCmdUI* pCmdUI) 
{pCmdUI->SetCheck(m_bcolor==2);}

