// MyWin.cpp : implementation file
//

#include "stdafx.h"
#include "float.h"
#include "MyWin.h"
#include "matedview.h"
#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// helper
void DrawBox()
{
	// draws the sides of a unit cube (0,0,0)-(1,1,1)

	glBegin(GL_POLYGON);//f1: front
		glNormal3f(-1.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,0.0f,1.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(1.0f,0.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);//f2: bottom
		glNormal3f(0.0f,0.0f,-1.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);// f3:back
		glNormal3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,1.0f,0.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(0.0f,1.0f,1.0f);
		glVertex3f(0.0f,1.0f,0.0f);
	glEnd();
	glBegin(GL_POLYGON);// f4: top
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(0.0f,0.0f,1.0f);
		glVertex3f(0.0f,1.0f,1.0f);
	glEnd();
	glBegin(GL_POLYGON);//f5: left
		glNormal3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);
		glVertex3f(0.0f,1.0f,0.0f);
		glVertex3f(0.0f,1.0f,1.0f);
		glVertex3f(0.0f,0.0f,1.0f);
	glEnd();
	glBegin(GL_POLYGON);//f6: right
		glNormal3f(0.0f,-1.0f,0.0f);
		glVertex3f(1.0f,0.0f,0.0f);
		glVertex3f(1.0f,0.0f,1.0f);
		glVertex3f(1.0f,1.0f,1.0f);
		glVertex3f(1.0f,1.0f,0.0f);
	glEnd();
}

//------------------------------------
// for the bezier surface

GLfloat ctrlpoints[4][4][3] = // [v][u][xyz] 
{
    {	
		{-1.5f, -1.5f, 4.0f}, {-0.5f, -1.5f, 2.0f}, 
		{0.5f, -1.5f, -1.0f}, {1.5f, -1.5f, 2.0f}
	},
		
    {
		{-1.5f, -0.5f, 1.0f}, {-0.5f, -0.5f, 3.0f}, 
		{0.5f, -0.5f, 0.0f}, {1.5f, -0.5f, -1.0f}
	}, 

    {
		{-1.5f, 0.5f, 4.0f}, {-0.5f, 0.5f, 0.0f}, 
		{0.5f, 0.5f, 3.0f}, {1.5f, 0.5f, 4.0f}
	}, 

    {
		{-1.5f, 1.5f, -2.0f}, {-0.5f, 1.5f, -2.0f}, 
		{0.5f, 1.5f, 0.0f}, {1.5f, 1.5f, -1.0f}
	}
};



/////////////////////////////////////////////////////////////////////////////
// CMyWin

CMyWin::CMyWin(CWnd* pW):COGLWnd(pW)
{
	// Window is created and we can 
	// set up the drawing environment

	SetUpDrawingEnvironment();
	ASSERT(m_hRC !=NULL);

	// do one-time initializing
	InitializeRContext();

	// set mousing around variables
	m_Vx=m_Vy=0.0f;
	m_dvy=m_dvx=0.0f;
	m_MovementInProgress=FALSE;

	
}

CMyWin::~CMyWin()
{
}


BEGIN_MESSAGE_MAP(CMyWin, COGLWnd)
	//{{AFX_MSG_MAP(CMyWin)
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMyWin message handlers
void CMyWin::DrawScene()
{
	// calc the viewing box according to
	// the scene you want to see
	GLfloat dx=1.5f;
	GLfloat dy=1.5f;
	// set the view
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	glOrtho(-dx,dx,-dy,dy,0.0f,100.0f);
	glMatrixMode(GL_MODELVIEW);

	if(pMain->m_smooth)
		glShadeModel(GL_SMOOTH);
	else
		glShadeModel(GL_FLAT);

	switch(pMain->m_bcolor)
	{
	case 0:	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);break;
	case 1:	glClearColor(0.8f, 0.8f, 0.8f, 0.0f);break;
	case 2:	glClearColor(1.0f, 1.0f, 1.0f, 0.0f);break;
	default:glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	}

	// Clear the color and depth buffers.
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	// looking down negative z
	glTranslatef(0.0f,0.0f,-5.0f);


	// tilt it around x
	glRotatef(m_Vx,1.0f,0.0f,0.0f);
	// tilt it around y
	glRotatef(m_Vy,0.0f,1.0f,0.0f);


	// set material according to data in view
	CMatedView* pW=(CMatedView*)(pMain->GetActiveView());
	GLfloat ambient[]={pW->m_a_red,pW->m_a_green,pW->m_a_blue};
	GLfloat diffuse[]={pW->m_d_red,pW->m_d_green,pW->m_d_blue};
	GLfloat specular[]={pW->m_s_red,pW->m_s_green,pW->m_s_blue};
	GLfloat shininess=pW->m_shine;

	glMaterialfv (GL_FRONT_AND_BACK, GL_AMBIENT, ambient);
	glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, diffuse);
	glMaterialfv (GL_FRONT_AND_BACK, GL_SPECULAR, specular);
	glMaterialf (GL_FRONT_AND_BACK, GL_SHININESS, shininess);


	GLUquadricObj *glpQ;
	switch(pMain->m_figtype)
	{
	case 0:
		// use a quadric to draw a sphere
		GLUquadricObj *glpQ;
		glpQ=gluNewQuadric();
		gluSphere(glpQ,1,20,20);
		gluDeleteQuadric(glpQ);
	break;
	case 1:
		// draw a box
		DrawBox();
	break;

	case 2:
		// draw a Bezier surface
		glEvalMesh2(GL_FILL, 0, 20, 0, 20);
	break;

	default:
		// use a quadric to draw a sphere
		glpQ=gluNewQuadric();
		gluSphere(glpQ,1,20,20);
		gluDeleteQuadric(glpQ);
	}
	
	// finnish drawing
	glFlush();
}

void CMyWin::InitializeRContext()
{
    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);
    
	// prepare ligthsource
	GLfloat ambient[] = {0.5f,0.5f,0.5f,1.0f };
    GLfloat diffuse[] = {1.0f,1.0f,1.0f,1.0f };
    GLfloat specular[] = {1.0f,1.0f,1.0f,1.0f };
    GLfloat position[] = {20.0f,30.0f,10.0f,0.0f };
    GLfloat lmodel_ambient[] = {0.4f,0.4f,0.4f,1.0f };


    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT0, GL_SPECULAR, specular);
    glLightfv(GL_LIGHT0, GL_POSITION, position);
	
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHTING);

	// prparing for Bezier
	glMap2f(GL_MAP2_VERTEX_3,0.0f,1.0f,3,4,0.0f,1.0f,12,4,&ctrlpoints[0][0][0]);
	glEnable(GL_MAP2_VERTEX_3);
	glEnable(GL_AUTO_NORMAL);
	glEnable(GL_NORMALIZE);
	glMapGrid2f(20,0.0f,1.0f,20,0.0f, 1.0f);

	
    // set default background to light gray
	glClearColor(0.8f, 0.8f, 0.8f, 0.0f);
}

void CMyWin::OnSize(UINT nType, int cx, int cy) 
{
	glViewport(0, 0, cx, cy);
	CWnd::OnSize(nType, cx, cy);

}

void CMyWin::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// User has pressed left button.Make a note
	// of this and prepare for intuitive rotation of scene
	m_PLast=point;
	SetCapture();
	m_dvy=m_dvx=0.0f;
	CWnd::OnLButtonDown(nFlags, point);
}

void CMyWin::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// free capture and terminate rotation
	ReleaseCapture();
	if(m_MovementInProgress)
		SetTimer(4,100,NULL); // keep on rolling
	else
	{
		KillTimer(4);
		m_dvy=m_dvx=0.0f;
	}

	CWnd::OnLButtonUp(nFlags, point);
}

void CMyWin::OnMouseMove(UINT nFlags, CPoint point) 
{
	// if left button is down and this is not a result of
	// a stop-click
	if(nFlags & MK_LBUTTON)
	{	
		// and has moved a significant dist
		if((abs(m_PLast.x-point.x)>1)||(abs(m_PLast.y-point.y)>1))
		{
			// then we find an intuitive rot angle
			CRect R;
			GetClientRect(&R);

			m_dvy=60.0f*((GLfloat (point.x-m_PLast.x))/GLfloat (R.Width()));
			m_dvx=60.0f*((GLfloat (point.y-m_PLast.y))/GLfloat (R.Height()));
			
			m_Vy=m_Vy+m_dvy;
			m_Vx=m_Vx+m_dvx;
			
			// rememeber point and force immediate redraw 
			m_PLast=point;
			RedrawWindow();
			m_MovementInProgress=TRUE;
		}
		else
		{
			m_MovementInProgress=FALSE;
		}
	}
}

void CMyWin::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// User has pressed right button.
	// will see popup menu

	CMenu menu; 
	VERIFY(menu.LoadMenu(IDR_MENU1));
	CMenu* pPopup = menu.GetSubMenu(0); 
	ASSERT(pPopup != NULL);
	
	// run it
	CRect R;
	GetWindowRect(&R);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		point.x+R.left, point.y+R.top, AfxGetMainWnd());
	CWnd::OnRButtonDown(nFlags, point);
}

void CMyWin::OnTimer(UINT nIDEvent) 
{
	m_Vy+=m_dvy;
	m_Vx+=m_dvx;
	RedrawWindow();
	CWnd::OnTimer(nIDEvent);
}



