//-------------------------------------
// matedView.h : interface of the CMatedView class
// subclassed from CFormView 
// Handles all controllers and updates 
// strings from scrollbars and vica versa
// b.stenseth - 2000
//-------------------------------------

#if !defined(AFX_MATEDVIEW_H__33740F8E_A0B3_11D2_B1E4_0060082D402F__INCLUDED_)
#define AFX_MATEDVIEW_H__33740F8E_A0B3_11D2_B1E4_0060082D402F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "mywin.h"
#include "mateddoc.h"



class CMatedView : public CFormView
{
protected: // create from serialization only
	CMatedView();
	DECLARE_DYNCREATE(CMatedView)


	CMyWin* m_pW;
	HGLRC m_oldRC;
	HDC m_oldDC;

	// current material
	GLfloat m_ambient[3];
	GLfloat m_diffuse[3];
	GLfloat m_specular[3];
	GLfloat m_shininess;

	// vector names
	CString str_amb,str_dif,str_spec,str_shine;

	// a material object to fill the combo
	CMaterialx m_Mat;
	int m_std_sel;


public:
	//{{AFX_DATA(CMatedView)
	enum { IDD = IDD_MATED_FORM };
	float	m_a_blue;
	float	m_a_green;
	float	m_a_red;
	float	m_d_blue;
	float	m_d_green;
	float	m_d_red;
	float	m_s_blue;
	float	m_s_green;
	float	m_s_red;
	float	m_shine;
	int		m_scr_a_blue;
	int		m_scr_a_green;
	int		m_scr_a_red;
	int		m_scr_d_blue;
	int		m_scr_d_green;
	int		m_scr_d_red;
	int		m_scr_s_blue;
	int		m_scr_s_green;
	int		m_scr_s_red;
	int		m_scr_shine;
	//}}AFX_DATA

// Attributes
public:
	CMatedDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMatedView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo*);
	//}}AFX_VIRTUAL

// Implementation
public:
	void UpdateImageAndCode();
	void ProduceCode();
	void LoadMaterial(int ix);
	virtual ~CMatedView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMatedView)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnChangeEdARed();
	afx_msg void OnChangeEdAGreen();
	afx_msg void OnChangeEdABlue();
	afx_msg void OnChangeEdDRed();
	afx_msg void OnChangeEdDGreen();
	afx_msg void OnChangeEdDBlue();
	afx_msg void OnChangeEdSRed();
	afx_msg void OnChangeEdSGreen();
	afx_msg void OnChangeEdSBlue();
	afx_msg void OnChangeEdShine();
	afx_msg void OnMenuSelStd();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in matedView.cpp
inline CMatedDoc* CMatedView::GetDocument()
   { return (CMatedDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MATEDVIEW_H__33740F8E_A0B3_11D2_B1E4_0060082D402F__INCLUDED_)
